############################################################
#                                                          #
#                   Time series                            #
#                                                          #
############################################################

#-------------------------------------------------------------------------------
# Plot per una estació determinada, en aquest cas: colnames(model_raw_at_AQMS)[1]

# r<-2
# 
# data_single     <- data.frame(date      = date_times,
#                               observations       = df_obs_sub[ ,colnames(model_raw_at_AQMS)[r] ],
#                               Model              = model_raw_at_AQMS_df[ ,colnames(model_raw_at_AQMS)[r]], 
#                               Model_corrected    = LOOCV_total_df[ ,colnames(model_raw_at_AQMS)[r]])
# 
# 
# openair::timePlot(selectByDate(data_single, year = 2021, month = 'January'),
#                     pollutant = c("observations","Model","Model_corrected"),
#                     group = TRUE,
#                     title =colnames(model_raw_at_AQMS)[r],
#                     y.relation = "free",
#                     ylab="NO2 (ug/m3)",
#                     cols = c("black", "blue", "grey"),
#                     lty = c("dotted","solid","dashed"),
#                     lwd = c(3,2,2),
#                     name.pol = c("observations","Raw model", "Corrected Model"))

#-------------------------------------------------------------------------------
# Plot per cada estació:
model_raw_at_AQMS=model_raw_at_AQMS_df
hourly_pollutants <- c("no2", "o3")
daily_pollutants  <- c("pm10", "pm2p5")
# month_names = c("January","February","March","April","May","June","July","August",
#                 "September","October","November","December")
#month_names = c("January")
for (station_code in names_local_stations) {
  
  # station_code <- names_local_stations[[1]]
  # if (station_code %in% colnames(df_obs_sub)) {
  #   obs_station <- df_obs_sub[ ,station_code]
  #   } else {obs_station <- NA}

  data_single     <- data.frame(date               = df_obs_sub$date,
                                observations       = df_obs_sub[ ,station_code],
                                Raw_Model          = model_raw_at_AQMS_df[ ,station_code], 
                                UK_Model           = LOOCV_total_df[ ,station_code])
  
  if(pollutant %in% hourly_pollutants){
    for (mm in month_names) { #no2, o3 per hora o dia separar (pm treure for)
      # TIME_PLOT
      png(file = paste0(save_time_series,station_code,"_",pollutant,"_",mm,".png"), width = 800, height = 400)
      openair::timePlot(selectByDate(data_single, year=read_year, month = mm),
                        pollutant = c("observations","Raw_Model","UK_Model"),
                        group = TRUE,                                    
                        title = station_code,
                        ylim = c(0, limit),
                        ylab=paste0(pollutant, " ", "(ug/m3)"),
                        cols = c("black", "blue", "grey"),
                        lty = c("dotted","solid","dashed"),
                        lwd = c(3,2,2),
                        name.pol = c("Observations", "Raw model", "UK Model"))
      dev.off()
    }
  } else if(pollutant %in% daily_pollutants){
    for (mm in month_names) { #no2, o3 per hora o dia separar (pm treure for)
      # TIME_PLOT
      png(file = paste0(save_time_series,station_code,"_",pollutant,"_",mm,".png"), width = 800, height = 400)
      openair::timePlot(data_single, #openair::selectByDate(data_single, year=read_year, month = mm),
                        pollutant = c("observations","Raw_Model","UK_Model"),
                        group = TRUE,                                    
                        title = station_code,
                        auto.text=FALSE, 
                        ci = FALSE,
                        plot.type = "h",
                        conf.int = c(0.75, 0.99),
                        ylim = c(0, limit),
                        cols = c("black", "blue", "grey"),
                        lty = c("dotted","solid","dashed"),
                        lwd = c(3,2,2),
                        name.pol = c("Observations", "Raw model", "UK Model"))
      dev.off()
    }
  }
                                
  
}

#-------------------------------------------------------------------------------
# Plot per la mitjana horària de totes les estacions:
#First, we create a matrix to put the data of observations and model (corrected and raw)

#month_names = c("January","February","March","April","May","June","July","August",
              #  "September","October","November","December")

obs_total            <- matrix(nrow = length_loop, ncol = 0) 
raw_model_total      <- matrix(nrow = length_loop, ncol = 0)
corr_model_total     <- matrix(nrow = length_loop, ncol = 0)

for (station_code in names_local_stations) {
  #obs_estacio           <-  df_obs_sub[ ,colnames(model_raw_at_AQMS)[i]]
  #df_obs_sub_t          <-  subset(df_obs_sub, select=-date)
  
  obs_estacio           <-  df_obs_sub[ ,station_code]
  raw_model_estacio     <-  model_raw_at_AQMS_df[ ,station_code]
  corr_model_estacio    <-  LOOCV_total_df[ ,station_code]
  
  obs_total             <- cbind(obs_total,obs_estacio)
  raw_model_total       <- cbind(raw_model_total,raw_model_estacio)
  corr_model_total      <- cbind(corr_model_total,corr_model_estacio) 
  
}

#Then, we calculate the means of each hour considering the whole stations
raw_model   <- data.frame( obs = rowMeans(obs_total,na.rm=TRUE),
                           mod = rowMeans(raw_model_total,na.rm=TRUE),
                           model="raw_model")

corr_model   <- data.frame( obs = rowMeans(obs_total,na.rm=TRUE),
                            mod = rowMeans(corr_model_total,na.rm=TRUE),
                            model="corr_model")

data_single   <- data.frame(date      = df_obs_sub$date,
                            observations       = raw_model$obs,
                            Model              = raw_model$mod,
                            Model_corrected    = corr_model$mod)

#for (mm in month_names) {
  png(file = paste0(save_general_statistics,"time_series_","daily_mean","_",pollutant,".png"), width = 800, height = 400)
  openair::timePlot(data_single, #selectByDate(data_single, year = 2021, month = mm),
                    pollutant = c("observations","Model","Model_corrected"),
                    plot.type = "h",
                    group = TRUE,
                    y.relation = "free",
                    ylab= paste0(pollutant, " ", "(ug/m3)"),
                    cols = c("black", "blue", "grey"),
                    lty = c("dotted","solid","dashed"),
                    lwd = c(3,2,2),
                    name.pol = c("observations","Raw model", "Corrected Model"))
  dev.off()
  
#}
